//! 2982. Find Longest Special Substring That Occurs Thrice II

pub struct Solution;

use std::collections::HashMap;

impl Solution {
    pub fn maximum_length(s: String) -> i32 {
        let mut len: Vec<usize> = vec![0; s.len()];
        let mut thrice_max_len: Vec<Vec<usize>> = vec![vec![0; 3]; 26];
        let mut previous_letter = ' ';
        for (index, letter) in s.chars().enumerate() {
            if index > 0 && letter == previous_letter {
                len[index] = len[index - 1] + 1;
            } else {
                len[index] = 1;
                previous_letter = letter;
            }
            let letter_index = letter as usize - 'a' as usize;
            if thrice_max_len[letter_index][0] < len[index] {
                thrice_max_len[letter_index][0] = len[index];
                thrice_max_len[letter_index].sort();
            }
        }
        let mut current_max: usize = 0;
        for thrice_len in thrice_max_len {
            println!("{:?}", thrice_len);
            if thrice_len[0] > 0 && current_max < thrice_len[0] {
                current_max = thrice_len[0];
            }
        }
        if current_max > 0 {
            return current_max as i32;
        } else {
            return -1;
        }
    }
}

#[cfg(test)]
mod tests {
    use crate::longest_special_substring::Solution;

    #[test]
    fn test_1() {
        let s = String::from("aaaa");
        assert_eq!(Solution::maximum_length(s), 2);
    }

    #[test]
    fn test_2() {
        let s = String::from("abcdef");
        assert_eq!(Solution::maximum_length(s), -1);
    }

    #[test]
    fn test_3() {
        let s = String::from("abcaba");
        assert_eq!(Solution::maximum_length(s), 1);
    }
}
